Subject: Re: smudge filters during checkout & crash consistency

From: Junio C Hamano <[email-masked]>
Date: Wed, 12 Nov 2014 10:30:09 -0800

Derek Moore <[email-masked]> writes:

> I have a case where I would like to smudge files according to the
> reflog information of the switching-to branch.

Don't do that.

When you have branches A, B and C, and a path F is the same between
branches A and B but different in branch C, if you start from branch
C and switch to branch A, F will be updated and obtain your smudge
tailored for "branch A's instance of F".

But if you then switch to B from that state, F will not even be
modified (i.e. it will keep the contents you prepared for "branch
A's instance of F").

In short, do not make clean/smudge depend on anything but blob
contents.